#include <jni.h>

#include "vbisam.h"

#include "dk_vajhoej_vbisam_NativeAPI.h"

JNIEXPORT jint JNICALL Java_dk_vajhoej_vbisam_NativeAPI_isopen(JNIEnv *env, jclass jc, jstring fnm, jint mode)
{
    const char *fnm2 = (*env)->GetStringUTFChars(env, fnm, 0);
    int stat = isopen(fnm2, mode);
    (*env)->ReleaseStringUTFChars(env, fnm, fnm2);
    return stat;
}

JNIEXPORT jint JNICALL Java_dk_vajhoej_vbisam_NativeAPI_iswrite(JNIEnv *env, jclass jc, jint db, jbyteArray buf)
{
    jbyte *buf2 = (*env)->GetByteArrayElements(env, buf, 0);;
    int stat = iswrite(db, (char *)buf2);
    (*env)->ReleaseByteArrayElements(env, buf, buf2, 0);
    return stat;
}

JNIEXPORT jint JNICALL Java_dk_vajhoej_vbisam_NativeAPI_isrewrite(JNIEnv *env, jclass jc, jint db, jbyteArray buf)
{
    jbyte *buf2 = (*env)->GetByteArrayElements(env, buf, 0);;
    int stat = isrewrite(db, (char *)buf2);
    (*env)->ReleaseByteArrayElements(env, buf, buf2, 0);
    return stat;
}

JNIEXPORT jint JNICALL Java_dk_vajhoej_vbisam_NativeAPI_isread(JNIEnv *env, jclass jc, jint db, jbyteArray buf, jint mode)
{
    jbyte *buf2 = (*env)->GetByteArrayElements(env, buf, 0);;
    int stat = isread(db, (char *)buf2, mode);
    (*env)->ReleaseByteArrayElements(env, buf, buf2, 0);
    return stat;
}

JNIEXPORT jint JNICALL Java_dk_vajhoej_vbisam_NativeAPI_isdelete(JNIEnv *env, jclass jc, jint db, jbyteArray buf)
{
    jbyte *buf2 = (*env)->GetByteArrayElements(env, buf, 0);;
    int stat = isdelete(db, (char *)buf2);
    (*env)->ReleaseByteArrayElements(env, buf, buf2, 0);
    return stat;
}

JNIEXPORT void JNICALL Java_dk_vajhoej_vbisam_NativeAPI_isclose(JNIEnv *env, jclass jc, jint db)
{
    isclose(db);
}
